<?php

//! Adapted from awstats: 
//! /usr/share/awstats/lib/robots.pm 
//! https://github.com/decadecity/AWStats-Enhancements/blob/master/lib/robots.pm
function demosphere_robots_regexp()
{
	$awstatsRobots = [
		# Common robots (In robot file)
		# Marcel added bots
		'AhrefsBot',
		'InAGist',
		'WikioLabsBot',
		'bingbot',
		'TweetedTimes',
		'MLBot',
		'Twitterbot',
		'PaperLiBot',
		'TweetmemeBot',
		'suggybot',
		# ...
		'appie',
		'architext',
		'bingpreview',
		'bjaaland',
		'contentmatch',
		'ferret',
		'googlebot\-image',
		'googlebot',
		'google\-sitemaps',
		'google[_+\s]web[_+\s]preview',
		'grabber',
		'gulliver',
		'virus[_+\s]detector',		# Must be before harvest
		'harvest',
		'htdig',
		'jeeves',
		'linkwalker',
		'lilina',
		'lycos[_+\s]',
		'moget',
		'muscatferret',
		'myweb',
		'nomad',
		'scooter',
		'slurp',
		'^voyager\/',
		'weblayers',
		# Common robots (Not in robot file)
		'antibot',
		'bruinbot',
		'digout4u',
		'echo!',
		'fast\-webcrawler',
		'ia_archiver\-web\.archive\.org', # Must be before ia_archiver to avoid confusion with alexa
		'ia_archiver',
		'jennybot',
		'mercator',
		'netcraft',
		'msnbot\-media',
		'msnbot-udiscovery',
		'msnbot',
		'petersnews',
		'relevantnoise\.com',
		'unlost_web_crawler',
		'voila',
		'webbase',
		'webcollage',
		'cfetch',
		'zyborg',	# Must be before wisenut
		'wisenutbot'
					 ];

	$awstatsRobots2 = [
		'007ac9',
		'[^a]fish',
		'abcdatos',
		'abonti\.com',
		'acme\.spider',
		'ahoythehomepagefinder',
		'ahrefsbot',
		'alkaline',
		'anthill',
		'arachnophilia',
		'arale',
		'araneo',
		'aretha',
		'ariadne',
		'powermarks',
		'arks',
		'aspider',
		'atn\.txt',
		'atomz',
		'auresys',
		'backrub',
		'bbot',
		'bigbrother',
		'blackwidow',
		'blindekuh',
		'bloodhound',
		'borg\-bot',
		'brightnet',
		'bspider',
		'cactvschemistryspider',
		'calif[^r]',
		'cassandra',
		'cgireader',
		'checkbot',
		'christcrawler',
		'churl',
		'cienciaficcion',
		'cms\scrawler',
		'collective',
		'combine',
		'conceptbot',
		'coolbot',
		'core',
		'cosmos',
		'crazywebcrawler',
		'cruiser',
		'cusco',
		'cyberspyder',
		'desertrealm',
		'deweb',
		'dienstspider',
		'digger',
		'diibot',
		'direct_hit',
		'dnabot',
		'domainappender',
		'download_express',
		'dragonbot',
		'dwcp',
		'e\-collector',
		'ebiness',
		'elfinbot',
		'emacs',
		'emcspider',
		'esther',
		'evliyacelebi',
		'fastcrawler',
		'feedcrawl',
		'fdse',
		'felix',
		'fetchrover',
		'fido',
		'finnish',
		'fireball',
		'fouineur',
		'francoroute',
		'freecrawl',
		'funnelweb',
		'gama',
		'gazz',
		'gcreep',
		'getbot',
		'geturl',
		'golem',
		'gougou',
		'grapnel',
		'griffon',
		'gromit',
		'gulperbot',
		'hambot',
		'havindex',
		'hometown',
		'htmlgobble',
		'hyperdecontextualizer',
		'iajabot',
		'iaskspider',
		'hl_ftien_spider',
		'sogou',
		'icjobs\.de',
		'iconoclast',
		'ilse',
		'imagelock',
		'incywincy',
		'informant',
		'infoseek',
		'infoseeksidewinder',
		'infospider',
		'inspectorwww',
		'intelliagent',
		'irobot',
		'iron33',
		'israelisearch',
		'javabee',
		'jbot',
		'jcrawler',
		'jobo',
		'jobot',
		'joebot',
		'jubii',
		'jumpstation',
		'kapsi',
		'katipo',
		'kilroy',
		'ko[_+\s]yappo[_+\s]robot',
		'kummhttp',
		'labelgrabber\.txt',
		'larbin',
		'legs',
		'linkidator',
		'linkscan',
		'lockon',
		'logo_gif',
		'macworm',
		'magpie',
		'marvin',
		'mattie',
		'mediafox',
		'merzscope',
		'meshexplorer',
		'mindcrawler',
		'mnogosearch',
		'momspider',
		'monster',
		'motor',
		'muncher',
		'mwdsearch',
		'ndspider',
		'nederland\.zoek',
		'netcarta',
		'netmechanic',
		'netscoop',
		'newscan\-online',
		'nhse',
		'northstar',
		'nzexplorer',
		'objectssearch',
		'occam',
		'octopus',
		'openfind',
		'orb_search',
		'packrat',
		'pageboy',
		'parasite',
		'patric',
		'pegasus',
		'perignator',
		'perlcrawler',
		'phantom',
		'phpdig',
		'piltdownman',
		'pimptrain',
		'pioneer',
		'pitkow',
		'pjspider',
		'plumtreewebaccessor',
		'poppi',
		'portalb',
		'psbot',
		'python',
		'raven',
		'rbse',
		'resumerobot',
		'rhcs',
		'road_runner',
		'robbie',
		'robi',
		'robocrawl',
		'robofox',
		'robozilla',
		'roverbot',
		'rules',
		'safetynetrobot',
		'semalt', #Note: This entry will not work as this crawler identifies itself
		# in the referrer string and not in the user agent string
		'search\-info',
		'search_au',
		'searchprocess',
		'senrigan',
		'sgscout',
		'shaggy',
		'shaihulud',
		'sift',
		'simbot',
		'sistrix', #Virus/trojan-infection? fr-crawler, ca-crawler? See https://www.projecthoneypot.org/ip_37.59.55.128, https://www.projecthoneypot.org/ip_198.27.80.144
		'site\-valet',
		'sitetech',
		'skymob',
		'slcrawler',
		'smartspider',
		'snooper',
		'solbot',
		'speedy',
		'spider[_+\s]monkey',
		'spiderbot',
		'spiderline',
		'spiderman',
		'spiderview',
		'spry',
		'sqworm',
		'ssearcher',
		'suke',
		'sunrise',
		'suntek',
		'sven',
		'tach_bw',
		'tagyu_agent',
		'tailrank',
		'tarantula',
		'tarspider',
		'techbot',
		'templeton',
		'titan',
		'titin',
		'tkwww',
		'tlspider',
		'ucsd',
		'udmsearch',
		'universalfeedparser',
		'urlck',
		'valkyrie',
		'verticrawl',
		'victoria',
		'visionsearch',
		'voidbot',
		'vwbot',
		'w3index',
		'w3m2',
		'wallpaper',
		'wanderer',
		'wapspIRLider',
		'webbandit',
		'webcatcher',
		'webcopy',
		'webfetcher',
		'webfoot',
		'webinator',
		'weblinker',
		'webmirror',
		'webmoose',
		'webquest',
		'webreader',
		'webreaper',
		'websnarf',
		'webspider',
		'webvac',
		'webwalk',
		'webwalker',
		'webwatch',
		'whatuseek',
		'whowhere',
		'wired\-digital',
		'wmir',
		'wolp',
		'wombat',
		'wordpress',
		'worm',
		'woozweb',
		'wwwc',
		'wz101',
		'xenu\slink\ssleuth',
		'xget',
		# Other robots reported by users
		'^finbot', #UA string starts with "finbot", should not match "elfinbot"
		'^webindex$', #UA should not match "webindexer"
		'1\-more_scanner',
		'360spider',
		'a6-indexer',
		'accoona\-ai\-agent',
		'activebookmark',
		'adamm_bot',
		'adsbot-google',
		'advbot',
		'affectv\.co\.uk',
		'almaden',
		'aipbot',
		'aleadsoftbot',
		'alpha_search_agent',
		'allrati',
		'aport',
		'applebot',
		'archive\-de\.com',
		'archive\.org_bot',
		'argus', 		# Must be before nutch
		'arianna\.libero\.it',
		'aspseek',
		'asterias',
		'awbot',
		'backlinktest\.com',
		'baiduspider',
		'becomebot',
		'bender',
		'betabot',
		'biglotron',
		'bittorrent_bot',
		'biz360[_+\s]spider',
		'blexbot',
		'blogbridge[_+\s]service',
		'bloglines',
		'blogpulse',
		'blogsearch',
		'blogshares',
		'blogslive',
		'blogssay',
		'bncf\.firenze\.sbn\.it\/raccolta\.txt',
		'bobby',
		'boitho\.com\-dc',
		'bookmark\-manager',
		'boris',
		'bubing',
		'bumblebee',
		'candlelight[_+\s]favorites[_+\s]inspector',
		'careerbot',
		'cbn00glebot',
		'ccbot',
		'cerberian_drtrs',
		'cfnetwork',
		'cipinetbot',
		'checkweb_link_validator',
		'cliqzbot',
		'commons\-httpclient',
		'computer_and_automation_research_institute_crawler',
		'converamultimediacrawler',
		'converacrawler',
		'copubbot',
		'cscrawler',
		'cse_html_validator_lite_online',
		'cuasarbot',
		'cursor',
		'custo',
		'datafountains\/dmoz_downloader',
		'dataprovider\.com',
		'daumoa',
		'daviesbot',
		'daypopbot',
		'deepindex',
		'deusu',
		'dipsie\.bot',
		'dnsgroup',
		'doccheckbot',
		'domainchecker',
		'domainsdb\.net',
		'dotbot',
		'duckduckgo-favicons-bot',
		'dulance',
		'dumbot',
		'dumm\.de\-bot',
		'earthcom\.info',
		'easydl',
		'eccp',
		'edgeio\-retriever',
		'ernst\s*2\.0',
		'ets_v',
		'exactseek',
		'extreme[_+\s]picture[_+\s]finder',
		'eventax',
		'everbeecrawler',
		'everest\-vulcan',
		'ezresult',
		'enteprise',
		'facebook',
		'facebot',
		'fast_enterprise_crawler.*crawleradmin\.t\-info@telekom\.de',
		'fast_enterprise_crawler.*t\-info_bi_cluster_crawleradmin\.t\-info@telekom\.de',
		'finderlein[_+\s]research[_+\s]crawler',
		'matrix_s\.p\.a\._\-_fast_enterprise_crawler', # must come before fast enterprise crawler
		'fast_enterprise_crawler',
		'fast\-search\-engine',
		'fastbot',
		'favicon',
		'favorg',
		'favorites_sweeper',
		'feedburner',
		'feedfetcher\-google',
		'feedflow',
		'feedster',
		'feedsky',
		'feedvalidator',
		'fetchbot',
		'filmkamerabot',
		'filterdb\.iss\.net',
		'findlinks',
		'findexa_crawler',
		'firmilybot',
		'foaf-search\.net',
		'fooky\.com\/ScorpionBot',
		'g2crawler',
		'gaisbot',
		'geniebot',
		'genieo',
		'gigablastopensource',
		'gigabot',
		'girafabot',
		'global_fetch',
		'gnodspider',
		'goforit\.com',
		'goforitbot',
		'gonzo',
		'grapeshot',
		'grub',
		'gpu_p2p_crawler',
		'henrythemiragorobot',
		'heritrix',
		'holmes',
		'hoowwwer',
		'hpprint',
		'htmlparser',
		'html[_+\s]link[_+\s]validator',
		'httrack',
		'hundesuche\.com\-bot',
		'i-bot',
		'icarus6j',
		'ichiro',
		'idmarch',
		'iltrovatore\-setaccio',
		'implisensebot',
		'infobot',
		'infociousbot',
		'infohelfer',
		'infomine',
		'insurancobot',
		'integromedb\.org',
		'internet[_+\s]ninja',
		'internetarchive',
		'internetseer',
		'internetsupervision',
		'ips\-agent',
		'irlbot',
		'isearch2006',
		'istellabot',
		'iupui_research_bot',
		'izsearch',
		'james\sbot',
		'jobboerse', #AWStats seems not to find this one despite the fact that "JobboerseBot" and "jobboerse.com" appear in the UA-string, maybe some previous entry matches
		'jrtwine[_+\s]software[_+\s]check[_+\s]favorites[_+\s]utility',
		'justview',
		'kalambot',
		'kamano\.de_newsfeedverzeichnis',
		'kazoombot',
		'kevin',
		'keyoshid', # Must come before Y!J
		'kinjabot',
		'kinja\-imagebot',
		'knowitall',
		'knowledge\.com',
		'kouaa_krawler',
		'krugle',
		'ksibot',
		'kurzor',
		'lanshanbot',
		'letscrawl\.com',
		'libcrawl',
		'linkbot',
		'linkdex\.com',
		'link_valet_online',
		'metager\-linkchecker',	# Must be before linkchecker
		'linkchecker',
		'linkstats\sbot',
		'lipperhey',
		'livejournal\.com',
		'lmspider',
		'loadtimebot',
		'lssrocketcrawler',
		'ltbot',
		'ltx71',
		'lwp\-request',
		'lwp\-trivial',
		'madaali\.de',
		'magpierss',
		'mail\.ru',
		'mapoftheinternet\.com',
		'meanpathbot',
		'mediabot',
		'mediapartners\-google',
		'megaindex',
		'megite',
		'memorybot',
		'metager2-verification-bot',
		'metajobbot', #Does not show up in the results of Sep. 2015 despite the fact that the corresponing log file has about 40 entries containing "MetaJobBot" in the UA string - strange.
		'metaspinner',
		'miadev',
		'microsoft\sbits',
		'microsoft.*discovery', # = 'microsoft (?:office (?:protocol|existence)|data access internet publishing provider protocol) discovery',
		'microsoft[_+\s]url[_+\s]control',
		'mindupbot',
		'mini\-reptile',
		'minirank',
		'missigua_locator',
		'misterbot',
		'miva',
		'mizzu_labs',
		'mj12bot',
		'mojeekbot',
		'msiecrawler',
		'ms[_+\s]search[_+\s]6\.0[_+\s]robot',
		'ms_search_4\.0_robot',
		'msrabot',
		'msrbot',
		'mt::telegraph::agent',
		'mydoyouhike',
		'nagios',
		'nasa_search',
		'netestate\sne\scrawler',
		'netluchs',
		'netsprint',
		'newsgatoronline',
		'nicebot',
		'nimblecrawler',
		'noxtrumbot',
		'npbot',
		'loocalcrawler\/nutch',
		'nutchcvs',
		'nutchosu\-vlib',
		'nutch',  # Must come after other nutch versions
		'ocelli',
		'octora_beta_bot',
		'omniexplorer[_+\s]bot',
		'onet\.pl[_+\s]sa',
		'onfolio',
		'opentaggerbot',
		'openwebspider',
		'optimizer',
		'oracle_ultra_search',
		'orangebot',
		'orbiter',
		'yodaobot',
		'qihoobot',
		'qwantify',
		'passwordmaker\.org',
		'pear_http_request_class',
		'peerbot',
		'perman',
		'php[_+\s]version[_+\s]tracker',
		'phpcrawl',
		'picmole',
		'pictureofinternet',
		'ping\.blo\.gs',
		'plinki',
		'pluckfeedcrawler',
		'plukkie',
		'pogodak',
		'pompos',
		'popdexter',
		'port_huron_labs',
		'postfavorites',
		'projectwf\-java\-test\-crawler',
		'proodlebot',
		'publiclibraryarchive',
		'pyquery',
		'rambler',
		'redalert',
		'riddler',
		'rogerbot',
		'rojo',
		'rssimagesbot',
		'ruffle',
		'rufusbot',
		'safeads\.xyz',
		'safesearch',
		'sandcrawler',
		'savetheworldheritage',
		'sbider',
		'schizozilla',
		'scumbot',
		'searchguild[_+\s]dmoz[_+\s]experiment',
		'searchmetricsbot',
		'seekbot',
		'semrushbot',
		'sensis_web_crawler',
		'seodiver',
		'seokicks\.de',
		'seoscanners',
		'seznambot',
		'shim\-crawler',
		'shoutcast',
		'sitedomain-bot',
		'siteexplorer\.info',
		'skimbot',
		'slysearch',
		'smtbot',
		'snap\.com_beta_crawler',
		'sohu\-search',
		'sohu', # "sohu agent"
		'snappy',
		'spbot',
		'sphere_scout',
		'spiderlytics',
		'spip',
		'sproose_crawler',
		'ssearch_bot',
		'steeler',
		'steroid__download',
		'stq_bot',
		'suchfin\-bot',
		'superbot',
		'surveybot',
		'susie',
		'syndic8',
		'syndicapi',
		'synoobot',
		'tcl_http_client_package',
		'technoratibot',
		'teragramcrawlersurf',
		'test_crawler',
		'testbot',
		'thumbsniper',
		't\-h\-u\-n\-d\-e\-r\-s\-t\-o\-n\-e',
		'topicblogs',
		'turnitinbot',
		'turtlescanner',		# Must be before turtle
		'turtle',
		'tutorgigbot',
		'twiceler',
		'ubicrawler',
		'ultraseek',
		'unchaos_bot_hybrid_web_search_engine',
		'unido\-bot',
		'unisterbot',
		'updated',
		'ustc\-semantic\-group',
		'vagabondo\-wap',
		'vagabondo',
		'vebidoobot',
		'vermut',
		'versus_crawler_from_eda\.baykan@epfl\.ch',
		'vespa_crawler',
		'voltron',
		'vortex',
		'vse\/',
		'w3c\-checklink',
		'w3c[_+\s]css[_+\s]validator[_+\s]jfouffa',
		'w3c_validator',
		'watchmouse',
		'wavefire',
		'waybackarchive\.org',
		'wbsearchbot',
		'webclipping\.com',
		'webcompass',
		'webcrawl\.net',
		'web_downloader',
		'webdup',
		'webfilter',
		'webindexer',
		'webminer',
		'website[_+\s]monitoring[_+\s]bot',
		'webvulncrawl',
		'wells_search',
		'wer-liefert-was',
		'wesee:search',
		'wevikabot',
		'wonderer',
		'wotbox',
		'wume_crawler',
		'wwweasel',
		'xenu\'s_link_sleuth',
		'xenu_link_sleuth',
		'xirq',
		'xovibot',
		'y!j', # Must come after keyoshid Y!J
		'yacy',
		'yahoo\-blogs',
		'yahoo\-verticalcrawler',
		'yahoofeedseeker',
		'yahooseeker\-testing',
		'yahooseeker',
		'yahoo\-mmcrawler',
		'yahoo!_mindset',
		'yandex',
		'flexum',
		'yanga',
		'yet-another-spider',
		'yisouspider',
		'yooglifetchagent',
		'z\-add_link_checker',
		'zealbot',
		'zhuaxia',
		'zspider',
		'zeus',
		'ng\/1\.', # put at end to avoid false positive
		'ng\/2\.', # put at end to avoid false positive
		'exabot',  # put at end to avoid false positive
		# Additional bots found by Sussex.
		'^[1-3]$', # Hiding bots. Doesn't appear to be a valid user agent.
		'alltop',
		'applesyndication',
		'asynchttpclient',
		'bingbot',
		'blogged_crawl',
		'bloglovin',
		'butterfly',
		'buzztracker',
		'carpathia',
		'catbot',
		'chattertrap',
		'check_http', #(nagios) a monitoring tool
		'coldfusion',
		'covario',
		'daylifefeedfetcher',
		'discobot',
		'dlvr\.it',
		'dreamwidth',
		'drupal',
		'ezoom',
		'feedmyinbox',
		'feedroll\.com',
		'feedzira',
		'fever\/',
		'freenews',
		'geohasher',
		'hanrss',
		'inagist',
		'jacobin\sclub',
		'jakarta',
		'js\-kit',
		'largesmall\scrawler',
		'linkedinbot',
		'longurl',
		'metauri',
		'microsoft\-webdav\-miniredir',
		'^motorola$',
		'movabletype',
		# These appear to be bots trying to hide. All of the usual architecture data is missing.
		'^mozilla\/3\.0\s\(compatible$',
		'^mozilla\/4\.0$',
		'^mozilla\/4\.0\s\(compatible;\)$',
		'^mozilla\/5\.0$',
		'^mozilla\/5\.0\s\(compatible;$',
		'^mozilla\/5\.0\s\(en\-us\)$',
		'^mozilla\/5\.0\sfirefox\/3\.0\.5$',
		'^msie',
		# End of hiding bots.
		'netnewswire',
		'\snetseer\s',
		'netvibes',
		'newrelicpinger',
		'newsfox',
		'nextgensearchbot',
		'ning',
		'pingdom',
		'pita',
		'postpost',
		'postrank',
		'printfulbot',
		'protopage',
		'proximic',
		'quipply',
		'r6\_',
		'ratingburner',
		'regator',
		'rome\sclient',
		'rpt\-httpclient',
		'rssgraffiti',
		'sage\+\+',
		'scoutjet',
		'simplepie',
		'sitebot',
		'summify\.com',
		'superfeedr',
		'synthesio',
		'teoma',
		'topblogsinfo',
		'topix\.net',
		'trapit',
		'trileet',
		'tweetedtimes',
		'twisted\spagegetter',
		'twitterbot',
		'twitterfeed',
		'unwindfetchor',
		'wazzup',
		'windows\-rss\-platform',
		'wiumi',
		'xydo',
		'yahoo!\sslurp',
		'yahoo\spipes',
		'yahoo\-newscrawler',
		'yahoocachesystem',
		'yahooexternalcache',
		'yahoo!\ssearchmonkey',
		'yahooysmcm',
		'yammer',
		# 'yandexbot', #already covered by 'yandex'
		'yeti',
		'yie8',
		'youdao',
		'yourls',
		'zemanta',
		'zend_http_client',
		'zumbot',
		# Other id that are 99% of robots
		'wget',
		'libwww',
		'^java\/[0-9]'   # put at end to avoid false positive
					  ];


return array_merge($awstatsRobots,$awstatsRobots2);
}
?>