// namespace
(function() {
window.demosphere_frontpage = window.demosphere_frontpage || {};
var ns=window.demosphere_frontpage;// shortcut

var moreOptionsHeight=0;
var cssLoaded=false;

window.onload = function()
{
	if(document.cookie.match('mobile-preference=0m')){µ("back-to-mobile").style.display='inline';}

	// Avoid JS errors on old browsers
	if(typeof document.body.classList==='undefined'){return;}

	// *** Add title attributes to event lines in JS (saves HTML bandwith)

	var trs = µ("calendar").getElementsByTagName("tr");
	var dr1=t('dr1'); 
	var dr2=t('dr2'); 
	for(var i=0,il=trs.length; i<il; i++)
	{
		var tr=trs[i];

		// add event topics titles
		var c0=tr.children[0];
		var classes=c0.parentNode.classList;
		for(var j=0;j<classes.length;j++)
		{
			if(classes[j].charAt(0)=="t")
			{
				c0.title+=(c0.title!="" ? ", ": "")+ns.topics[classes[j].substring(1)];
			}
		}

		// add dayrank titles 
		if(tr.classList.contains("dr1")){tr.children[2].title=dr1;}
		if(tr.classList.contains("dr2")){tr.children[2].title=dr2;}
	}

	// *** setup options values

	var isReload=Object.getOwnPropertyNames(option_values()).length;

	set_options_from_url();

	// *** Event listeners

	µ('topicSelect'        ).addEventListener('click',function(e){e.preventDefault();});
	µ('topicSelect'        ).addEventListener('mousedown',highlight_term);
	µ('near-lat-lng-button').addEventListener('mousedown',options_near_lat_lng);
	µ('more-options-button').addEventListener('mousedown',more_options);

	var l=document.querySelectorAll('#options>.form-item-select>select,#options>.form-item-checkbox>input');
	for(var i=0;i<l.length;i++)
	{
		l[i].addEventListener('change',options_update_calendar);
	}

	document.addEventListener('mousedown',function(e)
	{
		// FIXME: use e.target.closest('.options-popup') when supported
		var inPopup=false;
		for(var el=e.target;el;el=el.parentNode){if(el.classList && el.classList.contains('options-popup')){inPopup=el;}}
		if(µ('near-lat-lng-pwrap').classList.contains('open') && inPopup!==µ('near-lat-lng-popup') && e.target!==µ('near-lat-lng-button'))
		{
			µ('near-lat-lng-pwrap').classList.remove('open');
			move_calendar_below_popups();
		}
		if(µ('more-options').classList.contains('open') && inPopup!==µ('more-options-popup') && e.target!==µ('more-options-button'))
		{
			µ('more-options'      ).classList.remove('open');
			µ('more-options-popup').style.height=0;
			move_calendar_below_popups();
		}
	});

	if(isReload){options_update_calendar();}

}

// IE 11 workaround
function toggle(cl,c,b){if(b){cl.add(c);}else{cl.remove(c);}}

//! Event listener for click in topicSelect
//! Goes through all events (tr) and highlights / unhighlights rows.
function highlight_term(event)
{
	if(event.which!==1){return;}
	event.preventDefault();

	var topicButton=false;
	if(event.target.nodeName==="A"   ){topicButton=event.target.parentNode;}
	if(event.target.nodeName==="SPAN"){topicButton=event.target;}
	var term=topicButton===false ? false : topicButton.id.replace(/^sel/,'');
	if(topicButton===false || topicButton.classList.contains('highlighted')){term=false;}
	
	// classes: 
	// t123 : this line has term "123"
	// sel_t this line is currently selected
	// xs : wrong (grey) term

	// remove or add "highlightTopic" class name to dcal element
	toggle(document.querySelector(".dcal").classList,"highlightTopic",term!==false);

	// highlight/unhighlight selection boxes
	var selects=document.querySelectorAll("#topicSelect span");
	for (var i=0; i<selects.length; i++)
	{
		var sel=selects[i];
		var newHl="unhighlighted";
		if(sel.id=="sel"+term){newHl="highlighted";}
		sel.classList.remove('highlighted');
		sel.classList.remove('unhighlighted');
		if(term!==false){sel.classList.add(newHl);}
	}

	// Toggle "xs" and "sel_t" classes for each event (tr)
	var re=term==='others' ? /\bt[0-9]/ : false;
	var trs = µ("calendar").getElementsByTagName("tr");
	for (var i=0,il=trs.length; i<il; i++)
	{
		var tr = trs[i];

		if(term===false)
		{
			tr.classList.remove('sel_t');
			tr.classList.remove('xs');
		}
		else
		{
			var isSelected;
			if(term==='others'){isSelected=!re.test(tr.className);}
			else               {isSelected=tr.classList.contains('t'+term);}

			toggle(tr.classList,'sel_t', isSelected);
			toggle(tr.classList,'xs'   ,!isSelected);
		}
	}

	return false;
}

//! Fill in option form values from browser url GET arguments
function set_options_from_url()
{	
	var url=window.location.href;
	if(typeof userCalFakeUrl!=='undefined'){url=userCalFakeUrl+url.replace(/^https?:\/\/[^?]*/,'&');}
	var arg=url.indexOf("?")===-1 ? [] : url.split('?')[1].split('&');
	for(var i=0;i<arg.length;i++)
	{
		var camelName=arg[i].split('=')[0];
		var value="true";
		if(arg[i].indexOf('=')!==-1){value=arg[i].split('=')[1];}
		value=decodeURIComponent(value);
		var name=camelName.replace(/([A-Z])/g,'-$1').toLowerCase();
		if(name!=='near-lat-lng'){name='edit-'+name;}
		var el=µ(name);
		if(el===null || el.classList.contains('is-setup')){continue;}
		el.classList.add('is-setup');
		switch(camelName)
		{
			// simple int valued options
			case 'selectCityId':
			case 'selectPlaceReferenceId':
			case 'maxNbEventsPerDay':
			case 'mostVisited':
			case 'selectRecentChanges':
			case 'selectVocabTerm':
			case 'limit':
			el.value=parseInt(value);
			break;
			case 'selectTopic':
			el.value=value!=='others' ? parseInt(value) : 'others';
			break;
			// direct value
			case 'selectFpRegion':
			case 'mapShape':
			case 'selectVocabTermOr':
			el.value=value;
			break;
			// checkbox
			case 'orderByLastBigChanges':
			el.checked=value!=='false';
			break;
			// special cases
			case 'nearLatLng':
			value=value.split(',');
			µ('edit-near-lat-lng-use-map').checked='checked';
			µ('edit-near-lat-lng-latitude-and-longitude').value=value[0]+','+value[1];
			µ('edit-near-lat-lng-distance').value=value[2];
			break;
		}
	}
	var m=url.match(new RegExp('https?://[^/]*/'+demosphere_config.frontpage_regions_url_name+'/([^/]*)'));
	if(m && µ('edit-select-fp-region')!==null)
	{
		µ('edit-select-fp-region').value=m[1];
	}

	mark_changed_options();
}

//! Returns object with options that have been changed to non default.
//! Non jQuery version of demosphere_event_list_form_option_values()
//! Avoids loading that larger js file.
function option_values()
{
	var options={};
	var el;

	if(µ('edit-near-lat-lng-use-map')!==null &&
	   µ('edit-near-lat-lng-use-map').checked)
	{
		options.nearLatLng=µ('edit-near-lat-lng-latitude-and-longitude').value.split(',');
		options.nearLatLng.push(µ('edit-near-lat-lng-distance').value);
		options.nearLatLng=options.nearLatLng.join(',');
	}

	el=µ('edit-select-topic');
	if(el!==null && el.value!=='0'       ){options.selectTopic=parseInt(el.value);}
	if(el!==null && el.value==='others'  ){options.selectTopic='others';}

	el=µ('edit-select-city-id');
	if(el!==null && el.value!=='0'       ){options.selectCityId=parseInt(el.value);}

	el=µ('edit-select-fp-region');
	if(el!==null && el.value!=='0'       ){options.selectFpRegion=el.value;}

	el=µ('edit-max-nb-events-per-day');
	if(el!==null && el.value!=='0'       ){options.maxNbEventsPerDay=parseInt(el.value);}

	el=µ('edit-most-visited');
	if(el!==null && el.value!=='0'       ){options.mostVisited      =parseInt(el.value);}

	el=µ('edit-select-recent-changes');
	if(el!==null && el.value!=='0'       ){options.selectRecentChanges =parseInt(el.value);}

	el=µ('edit-order-by-last-big-changes');
	if(el!==null && el.checked           ){options.orderByLastBigChanges=true;}

	el=µ('edit-limit');
	if(el!==null && el.value.trim()!=='' ){options.limit    =el.value.trim();}

	el=µ('edit-select-vocab-term');
	if(el!==null && el.value.trim()!=='' ){options.selectVocabTerm=el.value.trim();}

	el=µ('edit-select-vocab-term-or');
	if(el!==null && el.value.trim()!=='' ){options.selectVocabTermOr=el.value.trim();}

	el=µ('edit-map-shape');
	if(el!==null && el.value.trim()!=='' ){options.mapShape =el.value.trim();}

	el=µ('edit-select-place-reference-id');
	if(el!==null && el.value!=='0'       ){options.selectPlaceReferenceId=el.value;}

	return options;
}

//! Adds "changed" class to non default options. 
//! Also updates options-extra/link
function mark_changed_options()
{
	var hasChange=false;
	var options=option_values();

	var l=document.querySelectorAll('#options .changed');
	for(var i=0;i<l.length;i++){l[i].classList.remove('changed');}
	for(var name in options) 
	{
		var id='edit-'+name.replace(/([a-z])([A-Z])/g,'$1-$2').toLowerCase()+'-wrapper';
		if(id=='edit-near-lat-lng-wrapper'){id='near-lat-lng-pwrap';}
		µ(id).classList.add('changed');
		hasChange=true;
	}
	// previous loop assumes form exists, which is not true for near-lat-lng 
	if((window.location.href.match(/nearLatLng=/)  || (typeof userCalFakeUrl!=='undefined' && userCalFakeUrl.match(/nearLatLng=/))) &&
	   !µ('near-lat-lng-pwrap').classList.contains('loaded'))
	{
		µ('near-lat-lng-pwrap').classList.add('changed');
		hasChange=true;
	}
	
	var url=base_url+'/'+
		(options.selectFpRegion ? demosphere_config.frontpage_regions_url_name+'/'+options.selectFpRegion : '')+
		(user_calendar() ? 'usercal/'+user_calendar() : '')+
		'?';
	for(var name in options) 
	{
		if(name==='selectFpRegion'){continue;}
		url+=name+"="+encodeURIComponent(options[name])+"&";
    }
	url=url.replace(/[&?]$/,'');
	µ('options-link' ).href=url;
	µ('options-extra').style.display=hasChange ? 'block' : 'none';
}

//! Returns uid if this is a user calendar
function user_calendar()
{
	var m1=window.location.href.match(/\/usercal\/([0-9]+)/);
	if(m1!==null){return parseInt(m1[1]);}
	var m2=window.location.href.match(/[?&]userCalendar=([0-9]+)($|[^0-9])/);
	if(m2!==null){return parseInt(m2[1]);}
}

//! Ajax load of main calendar. This is called whenever any form item is changed. 
function options_update_calendar()
{
	mark_changed_options();

	// *** create options from form items
	var options=option_values();

	// *** support for filtering in archive view
	if(window.location.href.match(/[?&]showArchiveLinks([=&]|$)/))
	{
		options.showArchiveLinks=true;
	}
	var selectStartTime=window.location.href.match(/[?&]selectStartTime=([0-9]+)([&]|$)/);
	if(selectStartTime!==null){options.selectStartTime=selectStartTime[1];}
	var endTime=window.location.href.match(/[?&]endTime=([0-9]+)([&]|$)/);
	if(endTime!==null){options.endTime=endTime[1];}

	if(user_calendar()){options.userCalendar=user_calendar();}

	// *** build url from options.
	var url=base_url+'/frontpage-options-calendar-update?';
	for(var name in options) 
	{
		url+=name+"="+encodeURIComponent(options[name])+"&";
    }
	url=url.replace(/[&?]$/,'');

	// don't refetch if no options changed
	if(url===window.lastCalendarUrl){return;} 
	window.lastCalendarUrl=url;
	
	ajax_get(url,function(response){µ("calendar").innerHTML=response;}); 
}

//! Event listener for map options button : open map popup
function options_near_lat_lng(e)
{
	if(e.which!==1){return;}
	if(e.target.id!=="near-lat-lng-button"){return;}
	e.preventDefault();
	var wrap=µ('near-lat-lng-pwrap'); 
	wrap.classList.toggle('open');
	move_calendar_below_popups();

	if(wrap.classList.contains('loaded') ){return;}
	if(wrap.classList.contains('loading')){return;}
	wrap.classList.add('loading');

	cssLoaded=false;
	// Wait for all script/css
	var end=function()
	{
		if(typeof jQuery!=='function'  || 
		   typeof demosphere_frontpage_options==='undefined' || 
		   typeof demosphere_event_list_form  ==='undefined' || 
		   typeof L                           ==='undefined' ||
		   cssLoaded===false || 
		   !µ('near-lat-lng-pwrap').classList.contains('loaded')){return;}
		demosphere_frontpage_options.setup_options(µ("near-lat-lng-popup"));
	};

 	ajax_get(base_url+'/frontpage-options-near-lat-lng',
			 function(response) 
 			 {
 				 µ("near-lat-lng-popup").innerHTML=response;
				 wrap.classList.add('loaded');
				 wrap.classList.remove('loading');
				 end();
				 move_calendar_below_popups();
 			 }); 
	if(typeof L!=='object')
	{
		add_css('lib/leaflet/leaflet.css',function(){cssLoaded=true;end();});
 		add_script(base_url+'/lib/leaflet/leaflet.js',true,end);
	}
 	if(typeof jQuery!=='function'                       )add_script(ns.jquery_js_path                      ,true,end);
 	if(typeof demosphere_frontpage_options==='undefined')add_script(ns.demosphere_frontpage_options_js_path,true,end);
 	if(typeof demosphere_event_list_form  ==='undefined')add_script(ns.demosphere_event_list_form_js_path  ,true,end);
	end();
}


//! Event listener for "+" options button : open more options popup
function more_options(e)
{
	if(e.which!==1){return;}
	if(e.target.id!=="more-options-button"){return;}
	e.preventDefault();
	var wrap =µ('more-options'); 
	var popup=µ("more-options-popup");
	wrap.classList.toggle('open');
	popup.style.height=(wrap.classList.contains('open') ? moreOptionsHeight : 0)+'px';
	
	move_calendar_below_popups();

	if(wrap.classList.contains('loaded' )){return;}
	if(wrap.classList.contains('loading')){return;}
	wrap.classList.add('loading');

	var end=function(){
		if(typeof jQuery!=='function'  || 
		   typeof demosphere_frontpage_options==='undefined' || 
		   typeof demosphere_event_list_form  ==='undefined' ||
		   typeof L                           ==='undefined' ||
		   !wrap.classList.contains('loaded')){return;}
		demosphere_frontpage_options.setup_options(popup);
	};

	ajax_get(base_url+'/frontpage-options-more-options'+(user_calendar() ? '?userCalendar='+user_calendar() : ''),
			function(response) 
 			{
 				popup.innerHTML=response;
				// compute actual size of this popup (it has hidden visibility)
				popup.style.height='auto';
				moreOptionsHeight=popup.getBoundingClientRect().height;		
				popup.style.height=0;
				wrap.classList.add('loaded');
				wrap.classList.remove('loading');
				end();
				// Transition does not work if set immediately.
				window.setTimeout(function(){popup.style.height=moreOptionsHeight+'px';},0);
				move_calendar_below_popups();
 			});

	if(typeof L!=='object')
	{
		add_css('lib/leaflet/leaflet.css',function(){cssLoaded=true;end();});
 		add_script(base_url+'/lib/leaflet/leaflet.js',true,end);
	}
 	if(typeof jQuery!=='function'                       )add_script(ns.jquery_js_path                      ,true,end);
 	if(typeof demosphere_frontpage_options==='undefined')add_script(ns.demosphere_frontpage_options_js_path,true,end);
 	if(typeof demosphere_event_list_form  ==='undefined')add_script(ns.demosphere_event_list_form_js_path  ,true,end);
	end();
}

//! Adjust calendar padding-top so that map & more popups don't overlap it.
function move_calendar_below_popups()
{
	var popupHeight=0;
	// We use transitions for animation, so current height is not available. 
	if(µ('near-lat-lng-pwrap').classList.contains('open')){popupHeight=300              +16+2;}
	if(µ('more-options'      ).classList.contains('open')){popupHeight=moreOptionsHeight+16+2;}
	var padding=0;
	if(popupHeight!==0)
	{
		padding=popupHeight-(µ('calendar').getBoundingClientRect().top-µ('options').getBoundingClientRect().bottom);
		padding=Math.max(0,padding);
	}
	µ('calendar').style.paddingTop=padding+"px";
}


// **** Tools

function µ(id){return document.getElementById(id);}

function add_css(path,cb)
{
	var css=document.createElement('link');
	path=base_url+'/'+path;
	css.type="text/css";
	css.rel="stylesheet";
	css.href=path+(window.demos_debug ? '?'+Math.random() : '');
	document.getElementsByTagName('head')[0].appendChild(css);
	if(typeof cb!=='undefined'){css.onload=cb;}
}

function ajax_get(url,callback)
{
	if(typeof ajax_get.currentRequest=='undefined'){ajax_get.currentRequest={};}
	var urlStart=url.replace(/\?.*$/,'');
	if(ajax_get.currentRequest[urlStart]){ajax_get.currentRequest[urlStart].abort();}
 	var req = new XMLHttpRequest();
	ajax_get.currentRequest[urlStart]=req;
	
 	req.onreadystatechange = function() 
 	{
 		if(req.readyState!=4){return;}
		ajax_get.currentRequest[urlStart]=false;
		if(req.status>=200 && req.status <400)
		{
 			callback(req.responseText,req);
		}
 	}; 
 	req.open('GET',url);
 	req.send(null); 	
}

// Exports
ns.add_script=add_script;
ns.add_css=add_css;
ns.set_options_from_url=set_options_from_url;
ns.move_calendar_below_popups=move_calendar_below_popups;
ns.options_update_calendar=options_update_calendar;

// end namespace wrapper
}());
